/* bibcite is a bibliography and citation library with exporting
and importing capabilities to bibTex format

Copyright (C) 2011  Georg Adelmann - mail@geoadel.net

This file is part of bibcite.

bibcite free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

package net.geoadel.bibcite.Database;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.UUID;
import net.geoadel.bibcite.DataFields.SessionData;
import net.geoadel.bibcite.DatabaseObjects.Bibliography;
import net.geoadel.bibcite.DatabaseObjects.Note;
import net.geoadel.bibcite.DatabaseObjects.Person;
import net.geoadel.bibcite.DatabaseObjects.Quotation;
import net.geoadel.bibcite.DatabaseObjects.dbObject;

/**
 *  Provides default data for testing & debugging purposes
 * @author Georg Adelmann
 */
public class DefaultDataset {
    public static ArrayList<dbObject> getDefaultDataset(){
        ArrayList<dbObject> alObjects = new ArrayList<dbObject>();
        
        Bibliography bib = new Bibliography(UUID.randomUUID(), "abstract", "adress", "booktitle", "", "how published", "institution", "journal", "authorlastnameYear", "organization", "publisher", "school", "series", "title", "article", "chapter", "edition", "12", "2011", "2", "1-42", "4", new ArrayList<String>(Arrays.asList("testauthor, test")), new ArrayList<String>(Arrays.asList("testeditor, test")), "license", "url", "typeTechReport", "ePrint", 0l, SessionData.getUser(), "subtitle", 0l, false, "language", "identifier", new ArrayList<String>(Arrays.asList("tag")));
        
        ArrayList<UUID> alRelatedToBib = new ArrayList<UUID>();
        alRelatedToBib.add(bib.getUUID());
        ArrayList<String> alTags = new ArrayList<String>();
        alTags.add("tag");
        alTags.add("quote");
        
        Quotation quote = new Quotation(UUID.randomUUID(), false, alRelatedToBib, alTags, "quoteKey", "The quote", "gist / summary", "1", "42", 0l);
        quote.setName("Testquote");
        
        Note note = new Note();
        note.setNoteText("testnote for testquote");
        note.addRelatedObject(quote.getUUID());
        note.setName("Testnote");
        
        Person person = new Person(SessionData.getUser());
        person.setAddressMail("test@geoadel.net");
        person.setName("Firstname Lastname");
        person.setIsAlive(true);
        person.setKey("");
        person.setBirthDate(200908221823L);
        
        alObjects.add(bib);
        alObjects.add(quote);
        alObjects.add(note);
        alObjects.add(person);

        return alObjects;
    }
}
