/* bibcite is a bibliography and citation library with exporting
and importing capabilities to bibTex format

Copyright (C) 2010  Georg Adelmann - mail@geoadel.net

This file is part of bibcite.

bibcite free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

package net.geoadel.bibcite.Events;

import java.util.EventObject;
import java.util.UUID;
import net.geoadel.bibcite.DatabaseObjects.dbObject;

/**
 * Provides a framework for a selection event that enables to retrieve the uuid of the selected element
 * @GPLStatus clean
 * @DocumentationStatus finished
 * @author  Georg Adelmann
  */
public class TreeViewSelectionEvent extends EventObject  {
    private boolean selectionEvent;
    private Object userObject;
    public TreeViewSelectionEvent(Object userObject, boolean selectionEvent){
            super(userObject);
            this.userObject = userObject;
            this.selectionEvent = selectionEvent;
    }

    public UUID getUUID(){
        return ((dbObject)userObject).getUUID();
    }

    public Object getUserObject(){
        return userObject;
    }
}
