/* bibcite is a bibliography and citation library with exporting
and importing capabilities to bibTex format

Copyright (C) 2010  Georg Adelmann - mail@geoadel.net

This file is part of bibcite.

bibcite free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

package net.geoadel.bibcite.FileFilters;

import java.io.File;

/**
 * Provides a file filter for common text files (pdf, txt, rtf and doc)
 * @GPLStatus clean
 * @DocumentationStatus finished
 * @author  Georg Adelmann
 */
public class FileFilter_text extends javax.swing.filechooser.FileFilter  {
    /**
     * A class that helps FileChooser to only show documents
     */

        public boolean accept(File file) {
            //Convert to lower case before checking extension - this way, the case does not matter (it displays DOc, dOC, doc, etc)
            return (file.getName().toLowerCase().endsWith(".pdf")
                    || (file.getName().toLowerCase().endsWith(".txt")
                    || (file.getName().toLowerCase().endsWith(".rtf")
                    || (file.getName().toLowerCase().endsWith(".doc")
                    || (file.getName().toLowerCase().endsWith(".odt")
                    || file.isDirectory()))))); // this last line is necessary for the filechooser - without it, directories would not be displayed
        }

        public String getDescription() {
            return "documents (*.pdf, *.txt, *.rtf, *.doc, *.odt)";
        }
    }

