/* bibcite is a bibliography and citation library with exporting
and importing capabilities to bibTex format

Copyright (C) 2010  Georg Adelmann - mail@geoadel.net

This file is part of bibcite.

bibcite free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

/*
 * ExportFilesGUI.java
 *
 * Created on Jun 20, 2011, 1:21:27 PM
 */

package net.geoadel.bibcite.GUI;

import java.io.File;
import java.util.ArrayList;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import net.geoadel.bibcite.DataFields.SessionData;
import net.geoadel.bibcite.Database.dbModel;
import net.geoadel.bibcite.Database.db4o;
import net.geoadel.bibcite.DatabaseObjects.dbFile;
import net.geoadel.bibcite.Tools.FileOperations;

/**
 *
 * @author Georg Adelmann
 */
public class ExportFilesGUI extends javax.swing.JPanel {
    ArrayList<dbFile> fileList = new ArrayList<dbFile>();
    JDialog dialog;

    /** Creates new form ExportFilesGUI */
    public ExportFilesGUI(JDialog dialog) {

        fileList = dbModel.getFilesNewestVersions();
        initComponents();

        this.dialog = dialog; // need to have a reference to the calling dialog to be able to dispose it        
    }

    public dbFile[] selectedFiles(){
        Object[] listObjects = listFiles.getSelectedValues();
        dbFile[] dbfiles = new dbFile[listObjects.length];
        int i = 0;
        for(Object object : listObjects){
            dbfiles[i] = (dbFile) object;
            i++;
        }
        return dbfiles;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        listFiles = new javax.swing.JList(fileList.toArray());
        jLabel5 = new javax.swing.JLabel();
        bExport = new javax.swing.JButton();

        listFiles.setToolTipText("Select individual bibliography entries you would want to export");
        jScrollPane1.setViewportView(listFiles);

        jLabel5.setText("Export Files");

        bExport.setText("Export selected files...");
        bExport.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bExportActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE)
                    .addComponent(jLabel5)
                    .addComponent(bExport, javax.swing.GroupLayout.Alignment.TRAILING))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 273, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(bExport)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void bExportActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bExportActionPerformed
                        //Create a file chooser
                final JFileChooser fc = new JFileChooser();
                fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

                //In response to a button click:
                int returnVal = fc.showOpenDialog(this);

                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    ProgressNotificator.setText("Importing files");
                    ProgressNotificator.setProgressIndeterminate(true);
                    File target = fc.getSelectedFile();
                    FileOperations.exportFiles(target, listFiles.getSelectedValues());
                }
                dialog.dispose();
    }//GEN-LAST:event_bExportActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bExport;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JList listFiles;
    // End of variables declaration//GEN-END:variables

}
