/* bibcite is a bibliography and citation library with exporting
and importing capabilities to bibTex format

Copyright (C) 2010  Georg Adelmann - mail@geoadel.net

This file is part of bibcite.

bibcite free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

/*
 * LoginRegisterGUI.java
 *
 * Created on 18.06.2010, 22:16:42
 */

package net.geoadel.bibcite.GUI;

import net.geoadel.bibcite.DataFields.Languages;
import net.geoadel.bibcite.Database.db4o;
import java.util.ArrayList;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JDialog;
import net.geoadel.bibcite.Database.dbModel;
import net.geoadel.bibcite.DatabaseObjects.User;

/**
 * Provides a Login Register and about GUI
 * @GPLStatus clean
 * @DocumentationStatus finished
 * @author Georg Adelmann
 */
public class LoginRegisterGUI extends javax.swing.JPanel {
    String exitStatus = "";

    JDialog dialog;
    String username;
    User user;
    String userpassword;

    ArrayList<String> alUsernames = new ArrayList<String>();

    /**
     *  provides a JPanel with a tabbed pane for log in, register and about view
     * @param fLogin    the JDialog that contains this GUI component for registering and logging in
     */
    LoginRegisterGUI(JDialog fLogin) {
        dialog = fLogin; // needed to be able to dispose the dialog, which embeds this panel
        alUsernames = dbModel.getUsernames();
        initComponents();
        // set the username language options by calling the bibcite.DataFields.language class
        cbRegisterLanguage.setModel(new DefaultComboBoxModel(Languages.getLanguages().toArray()));
        setVisible(true);
    }

    public String getUsername(){
        return username;
    }

    public String getUserPassword(){
        return userpassword;
    }
    public User getUser(){
        return user;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        pLogin = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        tfLoginUsername = new javax.swing.JTextField();
        bLogin = new javax.swing.JButton();
        tfLoginPassword = new javax.swing.JPasswordField();
        lLoginNotification = new javax.swing.JLabel();
        pRegister = new javax.swing.JPanel();
        lUsername = new javax.swing.JLabel();
        lPassword = new javax.swing.JLabel();
        tfRegisterPassword = new javax.swing.JPasswordField();
        tfRegisterUsername = new javax.swing.JTextField();
        cbRegisterLanguage = new javax.swing.JComboBox();
        lLanguage = new javax.swing.JLabel();
        bRegister = new javax.swing.JButton();
        cbUsername = new javax.swing.JCheckBox();
        cbPassword = new javax.swing.JCheckBox();
        pAbout = new javax.swing.JPanel();
        lGeoCiteVersion = new javax.swing.JLabel();
        lVersionValue = new javax.swing.JLabel();
        lAuthors = new javax.swing.JLabel();
        lDate = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        lDateValue = new javax.swing.JLabel();
        lWebsite = new javax.swing.JLabel();
        lWebsiteValue = new javax.swing.JLabel();
        lLicense = new javax.swing.JLabel();
        lLicenseValue = new javax.swing.JLabel();

        jLabel1.setText("Username");

        jLabel2.setText("Password");

        bLogin.setText("Login");
        bLogin.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bLoginActionPerformed(evt);
            }
        });

        tfLoginPassword.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tfLoginPasswordActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout pLoginLayout = new javax.swing.GroupLayout(pLogin);
        pLogin.setLayout(pLoginLayout);
        pLoginLayout.setHorizontalGroup(
            pLoginLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pLoginLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pLoginLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2)
                    .addComponent(jLabel1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pLoginLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(lLoginNotification, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(tfLoginUsername, javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(tfLoginPassword, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 171, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(bLogin)
                .addContainerGap(211, Short.MAX_VALUE))
        );
        pLoginLayout.setVerticalGroup(
            pLoginLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pLoginLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pLoginLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(tfLoginUsername, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pLoginLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(tfLoginPassword, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(bLogin))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lLoginNotification, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(74, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Login", pLogin);

        lUsername.setText("Username");

        lPassword.setText("Password");

        tfRegisterPassword.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                tfRegisterPasswordCaretUpdate(evt);
            }
        });

        tfRegisterUsername.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                tfRegisterUsernameCaretUpdate(evt);
            }
        });

        cbRegisterLanguage.setEditable(true);
        cbRegisterLanguage.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        cbRegisterLanguage.setToolTipText("The standard language set for bibliographies by default.");

        lLanguage.setText("Language");

        bRegister.setText("Register");
        bRegister.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bRegisterActionPerformed(evt);
            }
        });

        cbUsername.setFocusable(false);

        cbPassword.setFocusable(false);

        javax.swing.GroupLayout pRegisterLayout = new javax.swing.GroupLayout(pRegister);
        pRegister.setLayout(pRegisterLayout);
        pRegisterLayout.setHorizontalGroup(
            pRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pRegisterLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lUsername)
                    .addGroup(pRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(lLanguage, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(lPassword, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(cbRegisterLanguage, javax.swing.GroupLayout.Alignment.LEADING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(tfRegisterPassword, javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(tfRegisterUsername, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 184, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addGroup(pRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(bRegister)
                    .addComponent(cbUsername)
                    .addComponent(cbPassword))
                .addContainerGap(173, Short.MAX_VALUE))
        );
        pRegisterLayout.setVerticalGroup(
            pRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pRegisterLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lUsername)
                    .addComponent(tfRegisterUsername, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(cbUsername))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lPassword)
                    .addComponent(tfRegisterPassword, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(cbPassword))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cbRegisterLanguage, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lLanguage)
                    .addComponent(bRegister))
                .addContainerGap(65, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Register", pRegister);

        lGeoCiteVersion.setText("GeoCite Version");

        lVersionValue.setText(net.geoadel.bibcite.DataFields.Preferences.version);

        lAuthors.setText("Authors");

        lDate.setText("Date");

        jTextPane1.setEditable(false);
        jTextPane1.setText("Georg Adelmann (mail@geoadel.net)");
        jScrollPane2.setViewportView(jTextPane1);

        lDateValue.setText(net.geoadel.bibcite.DataFields.Preferences.versionDate);

        lWebsite.setText("Website");

        lWebsiteValue.setText("www.geoadel.net");

        lLicense.setText("License");

        lLicenseValue.setText("<html>BibCite is released under the GPL. <br>Libraries: db4o (GPL). <br>apache commons-lang, fontbox, jempbox, pdfbox, jasypt (Apache License 2.0).");

        javax.swing.GroupLayout pAboutLayout = new javax.swing.GroupLayout(pAbout);
        pAbout.setLayout(pAboutLayout);
        pAboutLayout.setHorizontalGroup(
            pAboutLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pAboutLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pAboutLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lGeoCiteVersion)
                    .addComponent(lAuthors)
                    .addComponent(lWebsite)
                    .addComponent(lLicense))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pAboutLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 392, Short.MAX_VALUE)
                    .addComponent(lWebsiteValue)
                    .addGroup(pAboutLayout.createSequentialGroup()
                        .addComponent(lVersionValue)
                        .addGap(18, 18, 18)
                        .addComponent(lDate)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lDateValue))
                    .addComponent(lLicenseValue, javax.swing.GroupLayout.DEFAULT_SIZE, 392, Short.MAX_VALUE))
                .addContainerGap())
        );
        pAboutLayout.setVerticalGroup(
            pAboutLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pAboutLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pAboutLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lGeoCiteVersion)
                    .addComponent(lVersionValue)
                    .addComponent(lDate)
                    .addComponent(lDateValue))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pAboutLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lAuthors)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(pAboutLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lLicense)
                    .addComponent(lLicenseValue, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pAboutLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lWebsite)
                    .addComponent(lWebsiteValue))
                .addContainerGap())
        );

        jTabbedPane1.addTab("About", pAbout);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 547, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 213, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    /**
     * If JButton bLogin was pressed, check, whether username and userpassword belong to one existing user in the database
     * if they do, close the dialog, if they don't give error message in GUI
     * @param evt
     */
    private void bLoginActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bLoginActionPerformed
        // System.out.println("Login-Button pressed");
        user = dbModel.loginUser(tfLoginUsername.getText(), String.valueOf(tfLoginPassword.getPassword()));
        if(user != null){
           userpassword = String.valueOf(tfLoginPassword.getPassword());
           username = tfLoginUsername.getText();

           dialog.dispose();
           exitStatus = "LOGIN";
        } else{
            username = null;
            lLoginNotification.setText("Wrong username or password.");
        }
    }//GEN-LAST:event_bLoginActionPerformed

    /**
     * register user, store given password in variable userpassword (but NOT in database later on)
     * and dispose this dialog
     * @param evt
     */
    private void bRegisterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bRegisterActionPerformed
        user = dbModel.registerUser(tfRegisterUsername.getText(), String.valueOf(tfRegisterPassword.getPassword()), (String) cbRegisterLanguage.getSelectedItem());
        username = tfRegisterUsername.getText();
        userpassword = String.valueOf(tfRegisterPassword.getPassword());
        dialog.dispose();
        exitStatus = "REGISTER";
    }//GEN-LAST:event_bRegisterActionPerformed

    private void tfLoginPasswordActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tfLoginPasswordActionPerformed
        // TODO add your handling code here:
        
    }//GEN-LAST:event_tfLoginPasswordActionPerformed

    /**
     * Check, whether username in JTextFieldtfRegisterUsername is already taken and if it is already taken
     * or too short, show message and disable JButton bRegister
     * @param evt
     */
    private void tfRegisterUsernameCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_tfRegisterUsernameCaretUpdate
        if(tfRegisterUsername.getText().length()<3){
            cbUsername.setText("too short (min. 3)");
            cbUsername.setSelected(false);
            bRegister.setEnabled(false);
        } else{
            cbUsername.setText("");
            cbUsername.setSelected(true);
            if(cbPassword.isSelected()){
                bRegister.setEnabled(true);
            }
        }
        if(alUsernames.contains(tfRegisterUsername.getText())){
            cbUsername.setText("Name not availlable");
            cbUsername.setSelected(false);
            bRegister.setEnabled(false);
        }
    }//GEN-LAST:event_tfRegisterUsernameCaretUpdate

    /**
     * Check whether the password is too short or username is not valid
     * If both username and password are valid, enable JButton bRegister
     * @param evt
     */
    private void tfRegisterPasswordCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_tfRegisterPasswordCaretUpdate
        if(tfRegisterPassword.getPassword().length<6){
            cbPassword.setText("too short (min. 6)");
            cbPassword.setSelected(false);
            bRegister.setEnabled(false);
        } else{
            cbPassword.setText("");
            cbPassword.setSelected(true);
            if(cbUsername.isSelected()){
                bRegister.setEnabled(true);
            }
        }
    }//GEN-LAST:event_tfRegisterPasswordCaretUpdate


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bLogin;
    private javax.swing.JButton bRegister;
    private javax.swing.JCheckBox cbPassword;
    private javax.swing.JComboBox cbRegisterLanguage;
    private javax.swing.JCheckBox cbUsername;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextPane jTextPane1;
    private javax.swing.JLabel lAuthors;
    private javax.swing.JLabel lDate;
    private javax.swing.JLabel lDateValue;
    private javax.swing.JLabel lGeoCiteVersion;
    private javax.swing.JLabel lLanguage;
    private javax.swing.JLabel lLicense;
    private javax.swing.JLabel lLicenseValue;
    private javax.swing.JLabel lLoginNotification;
    private javax.swing.JLabel lPassword;
    private javax.swing.JLabel lUsername;
    private javax.swing.JLabel lVersionValue;
    private javax.swing.JLabel lWebsite;
    private javax.swing.JLabel lWebsiteValue;
    private javax.swing.JPanel pAbout;
    private javax.swing.JPanel pLogin;
    private javax.swing.JPanel pRegister;
    private javax.swing.JPasswordField tfLoginPassword;
    private javax.swing.JTextField tfLoginUsername;
    private javax.swing.JPasswordField tfRegisterPassword;
    private javax.swing.JTextField tfRegisterUsername;
    // End of variables declaration//GEN-END:variables

}
