/* bibcite is a bibliography and citation library with exporting
and importing capabilities to bibTex format

Copyright (C) 2011  Georg Adelmann - mail@geoadel.net

This file is part of bibcite.

bibcite free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */
package net.geoadel.bibcite.GUI.ObjectEditors;

import java.awt.Component;
import java.awt.Dimension;
import java.util.ArrayList;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import net.geoadel.bibcite.DatabaseObjects.dbObject;

/**
 *
 * @author Georg Adelmann
 */
public class ComboBoxRevisionAccess extends JComboBox {

    public ComboBoxRevisionAccess(ArrayList<dbObject> revisions) {
        setRenderer(new CustomComboBoxRenderer());
        DefaultComboBoxModel model = new DefaultComboBoxModel();
        if (!revisions.isEmpty()) {
            for (dbObject object : revisions) {
                model.addElement(object);
            }
            setModel(model);
            setPreferredSize(new Dimension(150, 90));
            revalidate();
            updateUI();
        } else {
            //TODO: add current date
        }
    }

    class CustomComboBoxRenderer extends JLabel implements ListCellRenderer {

        public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
            setText(((dbObject) value).getDateEdited().toString());
            return this;
        }
    }
}
