/* bibcite is a bibliography and citation library with exporting
and importing capabilities to bibTex format

Copyright (C) 2010  Georg Adelmann - mail@geoadel.net

This file is part of bibcite.

bibcite free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

/*
 * FileExternalEditingDialog.java
 *
 * Created on Jul 18, 2010, 2:42:38 PM
 */

package net.geoadel.bibcite.GUI.ObjectEditors;

import java.io.File;
import javax.swing.JDialog;
import net.geoadel.bibcite.Database.dbModel;

/**
 * Offers a JPanel for choosing between three options of what to do with externally edited files
 * 
 * @author Georg Adelmann
 */
public class FileExternalEditingDialog extends javax.swing.JPanel {
    JDialog dialog;
    public String optionChosen = ""; // used to transfer the information which button was chosen to the parent

    /** Creates new form FileExternalEditingDialog */
    public FileExternalEditingDialog(JDialog dialog, boolean bNewlyCreatedFile, String name) {
        
        initComponents();
        jLabel1.setText("<html><body>File "+name+" is opened externally.<p>Once you finished editing/viewing please indicated how to proceed...");
        this.dialog = dialog; // needed to be able to dispose the dialog, which embeds this panel

        if(bNewlyCreatedFile){
            bStoreNewFile.setText("Store new file...");
            bCloseDoNothing.setText("Cancel");
            bOverwriteOldFile.setEnabled(false);
        }
    }

    public String getChosenOption(){
        return optionChosen;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        bStoreNewFile = new javax.swing.JButton();
        bOverwriteOldFile = new javax.swing.JButton();
        bCloseDoNothing = new javax.swing.JButton();

        jLabel1.setText("File xy is being viewed / edited in an external application.");

        bStoreNewFile.setText("Store in database as new revision");
        bStoreNewFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bStoreNewFileActionPerformed(evt);
            }
        });

        bOverwriteOldFile.setText("Overwrite existing file.");
        bOverwriteOldFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bOverwriteOldFileActionPerformed(evt);
            }
        });

        bCloseDoNothing.setText("Just erase temporary file.");
        bCloseDoNothing.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bCloseDoNothingActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 575, Short.MAX_VALUE)
                    .addComponent(bStoreNewFile, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 575, Short.MAX_VALUE)
                    .addComponent(bOverwriteOldFile, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 575, Short.MAX_VALUE)
                    .addComponent(bCloseDoNothing, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 575, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(bStoreNewFile)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(bOverwriteOldFile)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(bCloseDoNothing)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void bStoreNewFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bStoreNewFileActionPerformed
        optionChosen = "New";
        dialog.dispose();
        dbModel.updateTree();
    }//GEN-LAST:event_bStoreNewFileActionPerformed

    private void bOverwriteOldFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bOverwriteOldFileActionPerformed
        optionChosen = "Overwrite";
        dialog.dispose();
    }//GEN-LAST:event_bOverwriteOldFileActionPerformed

    private void bCloseDoNothingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bCloseDoNothingActionPerformed
        optionChosen = "Dispose";
        dialog.dispose();
    }//GEN-LAST:event_bCloseDoNothingActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bCloseDoNothing;
    private javax.swing.JButton bOverwriteOldFile;
    private javax.swing.JButton bStoreNewFile;
    private javax.swing.JLabel jLabel1;
    // End of variables declaration//GEN-END:variables

}
