/* bibcite is a bibliography and citation library with exporting
and importing capabilities to bibTex format

Copyright (C) 2010  Georg Adelmann - mail@geoadel.net

This file is part of bibcite.

bibcite free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

/*
 * TextAreaPanel.java
 *
 * Created on Jun 28, 2010, 5:37:33 PM
 */
package net.geoadel.bibcite.GUI.ObjectListPanels;

import javax.swing.JTextArea;
import javax.swing.JTextPane;
import javax.swing.text.StyledDocument;

/**
 * JPanel containing a simple JTextPane that helps editing text in a bigger window
 * 
 * @GPLStatus clean
 * @DocumentationStatus finished
 * @author Georg Adelmann
 */
public class TextAreaPanel extends javax.swing.JPanel {
    StyledDocument doc;
    JTextPane tpSource = new JTextPane();
    JTextArea taSource = new JTextArea();
    /** Creates new form TextAreaPanel */
    public String TextAreaPanel(JTextPane tpSource) {
        this.tpSource = tpSource;
        initComponents();
        tpText.setText(tpSource.getText()); // copy text of source tpSource JTextPane to this textpane
        return tpText.getText();
    }

    // in BibliographyEditor.java I used JTextAreas instead of JTextPane (like in QuotationEditor)
    // therefore this second constructor
    public String TextAreaPanel(JTextArea taSource) {
        this.taSource = taSource;
        initComponents();
        tpText.setText(taSource.getText()); // copy text of source tpSource JTextPane to this textpane
        return tpText.getText();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     *
     *
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane2 = new javax.swing.JScrollPane();
        tpText = new javax.swing.JTextPane();
        jToolBar1 = new javax.swing.JToolBar();
        bRemoveLineBreaks = new javax.swing.JButton();

        tpText.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                tpTextCaretUpdate(evt);
            }
        });
        jScrollPane2.setViewportView(tpText);

        jToolBar1.setRollover(true);

        bRemoveLineBreaks.setText("Remove line breaks");
        bRemoveLineBreaks.setFocusable(false);
        bRemoveLineBreaks.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        bRemoveLineBreaks.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        bRemoveLineBreaks.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bRemoveLineBreaksActionPerformed(evt);
            }
        });
        jToolBar1.add(bRemoveLineBreaks);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jToolBar1, javax.swing.GroupLayout.DEFAULT_SIZE, 386, Short.MAX_VALUE)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 386, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jToolBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    /**
     * if this textpane tpText text was changed, set its source TextPane to the same text
     * @param evt
     */
    private void tpTextCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_tpTextCaretUpdate
        tpSource.setText(tpText.getText());
        taSource.setText(tpText.getText());
    }//GEN-LAST:event_tpTextCaretUpdate

    private void bRemoveLineBreaksActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bRemoveLineBreaksActionPerformed
        tpText.replaceSelection(tpText.getSelectedText().replaceAll("-\n", ""));
        
        /**
         * tpText.setText(tpText.getText().replaceAll("[^.]\n", " "));
         * 
         *Pattern pattern = Pattern.compile("[^.]\n");
        Matcher matcher = pattern.matcher(tpText.getText());
        while(matcher.find()){
            System.out.println(matcher.group());
            
        }
         * */
    }//GEN-LAST:event_bRemoveLineBreaksActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bRemoveLineBreaks;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JTextPane tpText;
    // End of variables declaration//GEN-END:variables


}
