/* bibcite is a bibliography and citation library with exporting
and importing capabilities to bibTex format

Copyright (C) 2010  Georg Adelmann - mail@geoadel.net

This file is part of bibcite.

bibcite free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

/*
 * PreferencesEditor.java
 *
 * Created on Aug 23, 2010, 11:28:02 PM
 */

package net.geoadel.bibcite.GUI.Preferences;

import net.geoadel.bibcite.DataFields.SessionData;
import net.geoadel.bibcite.Database.db4o;
import net.geoadel.bibcite.Database.dbModel;

/**
 * Provides a JPanel allowing to edit user preferences
 *
 * @author Georg Adelmann
 */
public class PreferencesEditor extends javax.swing.JPanel {

    /** Creates new form PreferencesEditor */
    public PreferencesEditor() {
        initComponents();
        jTabbedPane1.add(new PreferencesUserSettings(), "User");
        // jTabbedPane1.add(new PreferencesUserGroups(), "Groups");
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jToolBar1 = new javax.swing.JToolBar();
        bSaveSettings = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();

        jToolBar1.setFloatable(false);
        jToolBar1.setRollover(true);

        bSaveSettings.setText("Save user settings");
        bSaveSettings.setFocusable(false);
        bSaveSettings.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        bSaveSettings.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        bSaveSettings.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bSaveSettingsActionPerformed(evt);
            }
        });
        jToolBar1.add(bSaveSettings);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jToolBar1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 522, Short.MAX_VALUE)
            .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 522, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jToolBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 302, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void bSaveSettingsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bSaveSettingsActionPerformed
        dbModel.storeUser(SessionData.getUser());
        // System.out.println("Stored user "+user.toString());
    }//GEN-LAST:event_bSaveSettingsActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bSaveSettings;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JToolBar jToolBar1;
    // End of variables declaration//GEN-END:variables
}
