/* bibcite is a bibliography and citation library with exporting
and importing capabilities to bibTex format

Copyright (C) 2010  Georg Adelmann - mail@geoadel.net

This file is part of bibcite.

bibcite free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

/*
 * ProgressNotificator.java
 *
 * Created on Aug 10, 2010, 11:55:18 PM
 */
package net.geoadel.bibcite.GUI;

import javax.swing.SwingUtilities;

/**
 * A rudimentary progress notificator for providing a progress bar and text field for giving status informations
 * @author Georg Adelmann
 */
public class ProgressNotificator extends javax.swing.JPanel {

    /** Creates new form ProgressNotificator */
    public ProgressNotificator() {
        initComponents();
    }

    public static void update(String text, int progress){
        lNotification.setText(text);
        jProgressBar1.setValue(progress);
    }

    public static void setText(String text) {
        lNotification.setText(text);
    }

    public static void setProgress(int progress) {
        jProgressBar1.setValue(progress);
    }

    public static void setProgressIndeterminate(final boolean state) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                jProgressBar1.setIndeterminate(state);
            }
        });
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jProgressBar1 = new javax.swing.JProgressBar();
        lNotification = new javax.swing.JLabel();

        setBorder(javax.swing.BorderFactory.createEtchedBorder());
        setMaximumSize(new java.awt.Dimension(32767, 10));
        setMinimumSize(new java.awt.Dimension(110, 25));
        setPreferredSize(new java.awt.Dimension(400, 25));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(lNotification, javax.swing.GroupLayout.PREFERRED_SIZE, 165, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(38, 38, 38)
                .addComponent(jProgressBar1, javax.swing.GroupLayout.DEFAULT_SIZE, 193, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lNotification, javax.swing.GroupLayout.DEFAULT_SIZE, 20, Short.MAX_VALUE)
                    .addComponent(jProgressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private static javax.swing.JProgressBar jProgressBar1;
    private static javax.swing.JLabel lNotification;
    // End of variables declaration//GEN-END:variables
}
