/*
Short program description

Copyright (C) 2010  Georg Adelmann - mail@geoadel.net

This file is part of program.

program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */
package net.geoadel.bibcite.GUI;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JToolBar;
import net.geoadel.bibcite.DatabaseObjects.Bibliography;
import net.geoadel.bibcite.DatabaseObjects.Note;
import net.geoadel.bibcite.DatabaseObjects.Person;
import net.geoadel.bibcite.DatabaseObjects.Quotation;
import net.geoadel.bibcite.DatabaseObjects.dbFile;
import net.geoadel.bibcite.Database.dbModel;

/**
 *
 * @author Georg Adelmann
 */
public class Toolbar {

    static JToolBar toolBarCategories;
    static JButton bCreatePerson = new JButton(new ImageIcon("/images/personCreate.png"));
    static JButton bImportFile = new JButton(new ImageIcon("/images/fileImport.png"));
    static JButton bCreateFile = new JButton(new ImageIcon("/images/fileCreate.png"));
    static JButton bCreateNote = new JButton(new ImageIcon("/images/noteCreate.png"));
    static JButton bCreateBib = new JButton(new ImageIcon("/images/bibCreate.png"));
    static JButton bCreateQuote = new JButton(new ImageIcon("/images/quoteCreate.png"));


    public static void showButtonsPerson(Person person) {
        bCreatePerson.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                dbModel.createPersonEditor();
            }
        });


        toolBarCategories.removeAll();
        toolBarCategories.add(bCreatePerson);
    }

    public static void showButtonsFile(dbFile file) {
        bImportFile.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                dbModel.importFile();
            }
        });

        bCreateFile.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                dbModel.createFile();
            }
        });


        toolBarCategories.removeAll();
        toolBarCategories.add(bImportFile);
        toolBarCategories.add(bCreateFile);
    }

    public static void showButtonsNote(Note note) {
        bCreateNote.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                dbModel.createNoteEditor();
            }
        });

        toolBarCategories.removeAll();
        toolBarCategories.add(bCreateNote);
    }

    public static void showButtonsBib(Bibliography bib) {
        bCreateBib.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                dbModel.createBibEditor();
            }
        });

        toolBarCategories.removeAll();
        toolBarCategories.add(bCreateBib);
    }

    public static void showButtonsQuote(Quotation quote) {
        bCreateQuote.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                throw new UnsupportedOperationException("Not supported yet.");
            }
        });

        toolBarCategories.removeAll();
        toolBarCategories.add(bCreateQuote);
    }
}
