/* bibcite is a bibliography and citation library with exporting
and importing capabilities to bibTex format

Copyright (C) 2010  Georg Adelmann - mail@geoadel.net

This file is part of bibcite.

bibcite free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

package net.geoadel.bibcite.ImportExport.DOIImport.Filters;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.UUID;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import net.geoadel.bibcite.DataFields.SessionData;
import net.geoadel.bibcite.DatabaseObjects.Bibliography;
import net.geoadel.bibcite.DatabaseObjects.dbObject;
import net.geoadel.bibcite.Tools.StringTools;

/**
 *
 * @author Georg Adelmann
 */
public class filterNature {

    public static Bibliography filter(String text) {
        String journalTitleBegin = "<meta name=\"citation_journal_title\" content=\"";
        String journalTitleEnd = "\" />";
        String volumeBegin = "<meta name=\"citation_volume\" content=\"";
        String volumeEnd = "\" />";
        String numberBegin = "<meta name=\"citation_issue\" content=\"";
        String numberEnd = "\" />";
        String articleTitleBegin = "<meta name=\"citation_title\" content=\"";
        String articleTitleEnd = "\" />";
        String pagesFromBegin = "<meta name=\"prism.startingPage\" content=\"";
        String pagesFromEnd = "\" />";
        String pagesToBegin =   "<meta name=\"prism.endingPage\" content=\"";
        String pagesToEnd = "\" />";
        String datePublishedBegin = "<meta name=\"citation_date\" content=\">";
        String datePublishedEnd = "\" />";


        String journalTitle = "";
        String volume = "";
        String number = "";
        String articleTitle = "";
        String authors = "";
        String pages = "";
        String datePublished = "";
        String publisher = "Nature Publishing";
        String month = "";
        String year = "";


        if (text.contains("Nature Publishing")) {
            journalTitle = text.substring(text.indexOf(journalTitleBegin) + journalTitleBegin.length(), text.indexOf(journalTitleEnd, text.indexOf(journalTitleBegin))).trim().replaceAll("&amp;", "&");
            volume = text.substring(text.indexOf(volumeBegin) + volumeBegin.length(), text.indexOf(volumeEnd, text.indexOf(volumeBegin))).trim();
            number = text.substring(text.indexOf(numberBegin) + numberBegin.length(), text.indexOf(numberEnd, text.indexOf(numberBegin))).trim();
            articleTitle = text.substring(text.indexOf(articleTitleBegin) + articleTitleBegin.length(), text.indexOf(articleTitleEnd, text.indexOf(articleTitleBegin))).trim();
            String pagesStart = text.substring(text.indexOf(pagesFromBegin) + pagesFromBegin.length(), text.indexOf(pagesFromEnd, text.indexOf(pagesFromBegin))).trim();
            String pagesEnd = text.substring(text.indexOf(pagesToBegin) + pagesToBegin.length(), text.indexOf(pagesToEnd, text.indexOf(pagesToBegin))).trim();
            pages = pagesStart +" - "+ pagesEnd;
            datePublished = text.substring(text.indexOf(datePublishedBegin) + datePublishedBegin.length(), text.indexOf(datePublishedEnd, text.indexOf(datePublishedBegin))).trim();

            month = StringTools.monthToInt(datePublished.substring(0, datePublished.indexOf(" ")));
            year = datePublished.substring(datePublished.lastIndexOf(", ") + 2).trim();

            Pattern pattern = Pattern.compile("<meta name=\"dc.creator\" content=\".+?\" />");
            Matcher matcher = pattern.matcher(text);
            int iMax = 0;

            while (matcher.find()) {
                iMax++;
            }

            matcher.reset();

            int i = 1;
            while (matcher.find()) {
                String entry = matcher.group();
                System.out.println(i+"/"+iMax+" adding author "+entry);

                authors = authors + entry.substring(entry.indexOf("content=\"") + 9, entry.indexOf("\" />"));
                if (i < iMax) {
                    authors = authors + " and ";
                }

                i++;
            }

            ArrayList<String> authorsList = new ArrayList<String>();
            String[] authorsArray = authors.split(" and ");
            authorsList.addAll(Arrays.asList(authorsArray));
            // System.out.println(authors);
            // System.out.println("authorsList: "+authorsList);

            ArrayList<String> editorsList = new ArrayList<String>();

            UUID uuid = UUID.randomUUID();


            Bibliography bib = new Bibliography(uuid, "", "", "", "", "", "", journalTitle, "", "", publisher, "", "", articleTitle, "article", "", "", month, year, number, pages, volume, authorsList, editorsList, "", "", "", "", 0L, SessionData.getUser(), "", new dbObject().setDateEdited(), false, SessionData.getUser().getPreferredLanguage(), "", new ArrayList<String>());

            return bib;
        }

        return null;
    }
}
