/* bibcite is a bibliography and citation library with exporting
and importing capabilities to bibTex format

Copyright (C) 2010  Georg Adelmann - mail@geoadel.net

This file is part of bibcite.

bibcite free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

package net.geoadel.bibcite.ImportExport.DOIImport.Filters;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.UUID;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import net.geoadel.bibcite.DataFields.SessionData;
import net.geoadel.bibcite.DatabaseObjects.Bibliography;
import net.geoadel.bibcite.DatabaseObjects.dbFile;
import net.geoadel.bibcite.DatabaseObjects.dbObject;
import net.geoadel.bibcite.Tools.InternetTools;
import net.geoadel.bibcite.Tools.StringTools;

/**
 *
 * @author Georg Adelmann
 */
public class filterSagePub {

    public static Bibliography filter(String text) {
        String journalTitleBegin = "<abbr title=\"";
        String journalTitleEnd = "\" class=\"slug-jnl-abbrev\">";
        String volumeBegin = "vol. ";
        String volumeEnd = "</span><span class=\"slug-issue\">";
        String numberBegin = "no. ";
        String numberEnd = "</span><span class=\"slug-pages\">";
        String articleTitleBegin = "<title>";
        String articleTitleEnd = "</title>";
        String pagesBegin = "<span class=\"slug-pages\">";
        String pagesEnd = "</span>";
        String datePublishedBegin = "slug-pub-date\">";
        String datePublishedEnd = "</span>";


        String journalTitle = "";
        String volume = "";
        String number = "";
        String articleTitle = "";
        String authors = "";
        String pages = "";
        String datePublished = "";
        String publisher = "Sage";
        String month = "";
        String year = "";


        if (text.contains("SAGE Publications")) {
            journalTitle = text.substring(text.indexOf(journalTitleBegin) + journalTitleBegin.length(), text.indexOf(journalTitleEnd)).trim().replaceAll("&amp;", "&");
            volume = text.substring(text.indexOf(volumeBegin) + volumeBegin.length(), text.indexOf(volumeEnd)).trim();
            number = text.substring(text.indexOf(numberBegin) + numberBegin.length(), text.indexOf(numberEnd)).trim();
            articleTitle = text.substring(text.indexOf(articleTitleBegin) + articleTitleBegin.length(), text.indexOf(articleTitleEnd)).trim();
            pages = text.substring(text.indexOf(pagesBegin) + pagesBegin.length(), text.indexOf(pagesEnd, text.indexOf(pagesBegin))).trim();
            datePublished = text.substring(text.indexOf(datePublishedBegin) + datePublishedBegin.length(), text.indexOf(datePublishedEnd, text.indexOf(datePublishedBegin))).trim();

            month = StringTools.monthToInt(datePublished.substring(0, datePublished.indexOf(" ")));
            year = datePublished.substring(datePublished.lastIndexOf(", ")+2).trim();

            Pattern pattern = Pattern.compile("<meta content=\".+?\" name=\"DC.Contributor\" />");
            Matcher matcher = pattern.matcher(text);
            int iMax = 0;

            while (matcher.find()){
                iMax++;
            }

            matcher.reset();

            int i = 1;
            while (matcher.find()) {
                String entry = matcher.group();
                // System.out.println(i+"/"+iMax+" adding author "+entry);

                authors = authors + entry.substring(entry.indexOf("=\"")+2,entry.indexOf("\" name=") );
                if(i < iMax){
                    authors = authors +" and ";
                }
                
                i++;
            }

            ArrayList<String> authorsList = new ArrayList<String>();
            String[] authorsArray = authors.split(" and ");
            authorsList.addAll(Arrays.asList(authorsArray));
            // System.out.println(authors);
            // System.out.println("authorsList: "+authorsList);

            ArrayList<String> editorsList = new ArrayList<String>();

            UUID uuid = UUID.randomUUID();

            Bibliography bib = new Bibliography(uuid, "", "", "", "", "", "", journalTitle, "", "", publisher, "", "", articleTitle, "article", "", "", month, year, number, pages, volume, authorsList, editorsList, "", "", "", "", 0L, SessionData.getUser(), "", new dbObject().setDateEdited(), false, SessionData.getUser().getPreferredLanguage(), "", new ArrayList<String>());

            return bib;
        }

        return null;
    }
}