/* bibcite is a bibliography and citation library with exporting
and importing capabilities to bibTex format

Copyright (C) 2010  Georg Adelmann - mail@geoadel.net

This file is part of bibcite.

bibcite free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

package net.geoadel.bibcite.ImportExport.ISBNImport.Filters;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.UUID;
import net.geoadel.bibcite.DataFields.SessionData;
import net.geoadel.bibcite.DatabaseObjects.Bibliography;
import net.geoadel.bibcite.DatabaseObjects.dbObject;
import net.geoadel.bibcite.Tools.StringTools;

/**
 *
 * @author Georg Adelmann
 */
public class filterISBNSearch {
    public static Bibliography filter(String html){
    Bibliography bib = new Bibliography(UUID.randomUUID(), "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", new ArrayList<String>(), new ArrayList<String>(), "", "", "", "", 0L , SessionData.getUser(), "", new dbObject().setDateEdited(), true, SessionData.getUser().getPreferredLanguage(), "", new ArrayList<String>());
        if(html.contains("<div class=\"bookinfo\">")){
            String data = html.substring(html.indexOf("<div class=\"bookinfo\">"), html.indexOf("</div>", html.indexOf("<div class=\"bookinfo\">")));
            if(data.contains("bookinfo")){
                int titleStart = data.indexOf("bookinfo")+18;
                int titleEnd = data.indexOf("</h2>", data.indexOf("bookinfo"));
                // System.out.println("Title: "+titleStart+" - "+titleEnd);
                bib.setTitle(data.substring(titleStart, titleEnd));
                // System.out.println("Title: "+bib.getTitle());
            }
            if(data.contains("Edition:</Strong>")){
                bib.setEdition(data.substring(data.indexOf("Edition:</Strong>")+17, data.indexOf("</p>", data.indexOf("Edition:</Strong>"))));
                // System.out.println("Edition: "+bib.getEdition());
            }
            if(data.contains("Authors:")){
                ArrayList<String> authorsList = new ArrayList<String>();
                int authorStart = data.indexOf("Authors:")+18;
                int authorEnd = data.indexOf("</p>", data.indexOf("Authors:"));
                // System.out.println("Authors: "+data.substring(authorStart, authorEnd));
                String[] authors = data.substring(authorStart, authorEnd).split("; ");
                for(String author:authors){
                    authorsList.add(author);
                }
                bib.setAuthors(authorsList);
                // System.out.println("Authors: "+bib.getAuthorNameAsText()+authorsList.size());
            }
            if(data.contains("Editors:</Strong>")){
                ArrayList<String> editorsList = new ArrayList<String>();
                String[] editors = data.substring(data.indexOf("Editors:</Strong>"), data.indexOf("</p>", data.indexOf("Editors:</Strong>"))).split("; ");
                for(String editor:editors){
                    editorsList.add(editor);
                    // System.out.println("Editors: "+bib.getEditorNameAsText());
                }
                bib.setEditors(editorsList);
            }
            if(data.contains("Publisher:</strong>")){
                bib.setPublisher(data.substring(data.indexOf("Publisher:</strong>")+20, data.indexOf("</p>", data.indexOf("Publisher:</strong>"))));
                // System.out.println("Publisher: "+bib.getPublisher());
            }
            if(data.contains("Published:</strong>")){
                String date = data.substring(data.indexOf("Published:</strong>")+19, data.indexOf("</p>", data.indexOf("Published:</strong>"))).trim();
                String month = String.valueOf(StringTools.monthToInt(date.substring(0, date.indexOf(" ")))).trim();
                String year = date.substring(date.indexOf(" ")).trim();
                bib.setYear(year);
                bib.setMonth(month);
                // System.out.println("Year: "+bib.getYear()+"    Month: "+bib.getMonth());
            }
        }
    return bib;
    }
}
