/* bibcite is a bibliography and citation library with exporting
and importing capabilities to bibTex format

Copyright (C) 2010  Georg Adelmann - mail@geoadel.net

This file is part of bibcite.

bibcite free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */


package net.geoadel.bibcite.ImportExport.ISBNImport;

import net.geoadel.bibcite.DatabaseObjects.Bibliography;
import net.geoadel.bibcite.GUI.ProgressNotificator;
import net.geoadel.bibcite.ImportExport.ISBNImport.Filters.filterISBNSearch;
import net.geoadel.bibcite.ImportExport.ISBNImport.Filters.filterOttoBib;
import net.geoadel.bibcite.Tools.InternetTools;

/**
 *
 * @author Georg Adelmann
 */
public class Import_ISBN {

    public static Bibliography importByISBN(String isbn) {
        Bibliography bib = null;
        // String html = InternetTools.getHTML("http://www.isbnsearch.org/isbn/"+isbn.replaceAll("-", ""));
        String html = InternetTools.getHTML("http://ottobib.com/isbn/"+isbn.replaceAll("-", "")+"/bibtex");
        
        // System.out.println("Analyzing html result for ISBN "+isbn);

        bib = filterOttoBib.filter(html);
        return bib;
    }

}
