/* bibcite is a bibliography and citation library with exporting
and importing capabilities to bibTex format

Copyright (C) 2010  Georg Adelmann - mail@geoadel.net

This file is part of bibcite.

bibcite free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */
package net.geoadel.bibcite.Tools;

import java.util.ArrayList;
import java.util.Scanner;

/**
 * A helper class for dealing with strings
 * 
 * @author Georg Adelmann
 */
public class StringTools {

    public static String cleanString(String s) {
        s = s.trim();
        s = s.replaceAll("\\t", "");
        while (s.contains("  ")) {
            s = s.replaceAll("  ", " ");
        }
        if (s.startsWith("\"")) {
            s.substring(1, s.length());
            if (s.endsWith("\"")) {
                s.substring(0, s.length() - 1);
            }
            if (s.endsWith("\",")) {
                s.substring(0, s.length() - 2);
            }
        }
        return s;
    }

    public static String monthToInt(String monthName) {
        monthName = monthName.toLowerCase().trim();
        if (monthName.equals("january") || monthName.contains("jan")) {
            return ("1");
        }
        if (monthName.equals("february")|| monthName.contains("feb")) {
            return ("2");
        }
        if (monthName.equals("march")|| monthName.contains("mar")) {
            return ("3");
        }
        if (monthName.equals("april")|| monthName.contains("apr")) {
            return ("4");
        }
        if (monthName.equals("may")) {
            return ("5");
        }
        if (monthName.equals("june")|| monthName.contains("jun")) {
            return ("6");
        }
        if (monthName.equals("july")|| monthName.contains("jul")) {
            return ("7");
        }
        if (monthName.equals("august")|| monthName.contains("aug")) {
            return ("8");
        }
        if (monthName.equals("september")|| monthName.contains("sep")) {
            return ("9");
        }
        if (monthName.equals("october")|| monthName.contains("oct")) {
            return ("10");
        }
        if (monthName.equals("november")|| monthName.contains("nov")) {
            return ("11");
        }
        if (monthName.equals("december")|| monthName.contains("dec")) {
            return ("12");
        }
        return("0");
    }


        /**
     * @param text
     * @return  ArrayList, containing the names, one per line
     */
    public static ArrayList<String> parseNamesTextArea(String text) {
        ArrayList<String> names = new ArrayList<String>();
        Scanner scanner = new Scanner(text);
        // set the appropriate delimiter by checking which one likely is used
        scanner.useDelimiter(System.getProperty("line.separator"));

        // some bibtex formats choose 'AND' for delimiting different names, e.g. http://www.plosone.org/article/getBibTexCitation.action?articleURI=info%3Adoi%2F10.1371%2Fjournal.pone.0011372
        if (text.contains(" AND ")) {
            scanner.useDelimiter(" AND ");
        }
        if (text.contains(" and ")) {
            scanner.useDelimiter(" and ");
        }
        // some bibtex formats choose '; ' or other delimiters - these should be handled here for delimiting different names
        if (text.contains("; ")) {
            scanner.useDelimiter("; ");
        }
        while (scanner.hasNext()) {
            String name = scanner.next().replaceAll("(\\r|\\n|\\t)", "");
            if(!name.isEmpty()){
                if(name.contains(", ")){
                    name = name.substring(name.indexOf(", ")+1).trim()+ " "+name.substring(0, name.indexOf(", ")).trim();
                }
               names.add(name);
               // System.out.println("Added author "+name);
            }
        }
        return names;
    }
}
